import pygame, sys, random, time
from pygame.locals import *

class EnemyTarget:
    def loadImage(self, enemyType):
        self.enemyType = enemyType
        self.image = []
        if self.enemyType == "parachute":
            self.image.append( pygame.image.load("img/parachute_sz1.png") )
            self.image.append( pygame.image.load("img/parachute_sz2.png") )
            self.image.append( pygame.image.load("img/parachute_sz3.png") )
            self.image.append( pygame.image.load("img/parachute_sz4.png") )
            self.image.append( pygame.image.load("img/parachute_sz5.png") )

        elif self.enemyType == "plane_down_left":
            self.image.append( pygame.image.load("img/plane_sz1.png") )
            self.image.append( pygame.image.load("img/plane_sz2.png") )
            self.image.append( pygame.image.load("img/plane_sz3.png") )
            self.image.append( pygame.image.load("img/plane_sz4.png") )
            self.image.append( pygame.image.load("img/plane_sz5.png") )

        elif self.enemyType == "bomb":
            self.image.append( pygame.image.load("img/bomb_sz1.png") )
            self.image.append( pygame.image.load("img/bomb_sz2.png") )
            self.image.append( pygame.image.load("img/bomb_sz3.png") )
            self.image.append( pygame.image.load("img/bomb_sz4.png") )
            self.image.append( pygame.image.load("img/bomb_sz5.png") )


    def parachute(self, sector):
        self.sector = sector
        self.sectorDict = {0:(100, 50), 1:(200, 50), 2:(300, 50), 3:(400, 50),
                           4:(500, 50)}
        self.sectorCenter = self.sectorDict[sector]
        self.img = self.image[0]
        self.rect = self.img.get_rect(left = self.sectorCenter[0], 
                                           top = self.sectorCenter[1])

    def bomb(self, sector):
        self.sector = sector
        self.sectorDict = {0:(100, 50), 1:(200, 50), 2:(300, 50), 3:(400, 50),
                           4:(500, 50)}
        self.sectorCenter = self.sectorDict[sector]
        self.img = self.image[0]
        self.rect = self.img.get_rect(left = self.sectorCenter[0], 
                                           top = self.sectorCenter[1])


    def plane(self, sector):
        self.sector = sector
        self.sectorDict = {0:(100, 50), 1:(200, 50), 2:(300, 50), 3:(400, 50),
                           4:(500, 50)}
        self.sectorCenter = self.sectorDict[sector]

        self.img = self.image[0]
        self.rect = self.img.get_rect(left = self.sectorCenter[0], 
                                           top = self.sectorCenter[1])


    def setPosition(self, startSpeed):
        self.speed = startSpeed
        if self.rect.bottom <= 150:
            self.img = self.image[0]
        elif self.rect.bottom > 150 and self.rect.bottom <= 275:
            self.img = self.image[1]
            self.speed = startSpeed + 2
        elif self.rect.bottom > 275 and self.rect.bottom <= 400:
            self.img = self.image[2]
            self.speed = startSpeed + 4
        elif self.rect.bottom > 400 and self.rect.bottom <= 525:
            self.img = self.image[3]
            self.speed = startSpeed + 6
        else:
            self.img = self.image[4]
            self.speed = startSpeed + 8


        self.rect = self.img.get_rect(top = self.rect.top, left = self.rect.left)


                
    def move(self):
        self.rect.bottom = self.rect.bottom + self.speed

        if self.enemyType == "plane_down_left":
            self.rect.left = self.rect.left - self.speed

        


GREEN = (0, 255, 0)
BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)

pygame.init()
WIDTH = 800
HEIGHT = 600

windowSurface = pygame.display.set_mode((WIDTH, HEIGHT), 0, 32)

### SPEED OF GAME  ###
planespeed = 1
targetStartSpeed = 1
playerGunSpeed = 7

currentPlaneSpeed = planespeed

explode_snd = pygame.mixer.Sound("snd/explosion.wav")
clock = pygame.time.Clock()

pistol_snd = pygame.mixer.Sound("snd/pistol_shot.wav")

### Tells the number of joysticks/error detection
joystick_count = pygame.joystick.get_count()

if joystick_count == 0:
    print ("No joystick found.  Use the keyboard")
else:
    my_joystick = pygame.joystick.Joystick(0)
    my_joystick.init()

crosshair_img = pygame.image.load("img/crosshairs.png")
background = pygame.image.load("img/warzone_stock.jpg")


### set the initial postion of the first plane
plane1 = EnemyTarget()
plane1.loadImage("plane_down_left")
plane1.plane(4)



#### set the initial position of the crosshair for the player's gun
x = 300
y = 300
### Creates rectangle
crosshair_rect = pygame.Rect( x, y, 100, 100)
crosshairCenterRect = pygame.Rect(x, y, 5, 5)
Back = pygame.Rect(0, 0, 800, 600)

## create list of enemies
enemies =[plane1]

## for loop adds multiple enemies and appends it to the list
## 
# for para in range (0, 2):
#    para = EnemyTarget()
#    para.loadImage("parachute")
#    ## pass sector position to parachute
#    para.parachute(random.randrange(0,4))
#    enemies.append(para)

for bom in range (0, 2):
    bom = EnemyTarget()
    bom.loadImage("bomb")
    ## pass sector position to bomb
    bom.bomb(random.randrange(0,4))
    enemies.append(bom)


#### Gun
gun_img = pygame.image.load("img/gun/rocket.png")
gun_rect = gun_img.get_rect(centerx = WIDTH/2, bottom = HEIGHT)

### Text Boxes
gameFont = pygame.font.SysFont("arialblack", 20)
## Time
gameTimeSurface = gameFont.render("Time: ", True, (255, 0, 0))
timerBox = pygame.Rect(5, 5, 50, 30)
startTime = time.time()

## Missed

enemiesBox = pygame.Rect(200, 5, 100, 30)
enemiesNumber = 0
enemiesSurface = gameFont.render("Enemies Landed: " + str(enemiesNumber), True, (255, 0, 0))


## enemies shot

killBox = pygame.Rect(550, 5, 100, 30)
killNumber = 0
killSurface = gameFont.render("Kills : " + str(killNumber), True, (255, 0, 0))

## game over
gameOverFont = pygame.font.SysFont("arialblack", 60)
gameOverSurface = gameOverFont.render("GAME OVER", True, (255, 0, 0))
gameOverBox = gameOverSurface.get_rect(center = (WIDTH/2, HEIGHT/2))
gameOverImg = pygame.image.load("img/soldiers_three.png")

## initial screen
initialSurface = pygame.image.load("img/soldier_face.jpg")
initialRect = windowSurface.get_rect()
# initialTimer = pygame.time.Clock()
initialTime = time.time()

### background music
back_music = pygame.mixer.music.load("snd/takelead.mp3")
pygame.mixer.music.set_volume(.5)
pygame.mixer.music.play(-1)

gameOver = False

initialScreen = True
Fire = 0
turbo = 0
h_axis_pos = 0
v_axis_pos = 0

### Begin Main Game Loop ##
while True:
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
        
        elif event.type == KEYDOWN:
            if gameOver == True:
                if event.key == ord('y'):
                    print("y key pressed")
                    startTime = time.time()
                    elapsedTime = 0
                    killNumber = 0
                    enemiesNumber = 0
                    gameOver = False
                    pygame.mixer.music.play(-1)
                if event.key == ord('n'):
                    pygame.quit()
                    sys.exit()
            elif not gameOver:
                ## put some code here to use the keyboard
                if event.key == K_RIGHT:
                    ## handle right
                    h_axis_pos = 1 
                elif event.key == K_LEFT:
                    h_axis_pos = -1
                elif event.key == K_UP:
                    v_axis_pos = -1
                elif event.key == K_DOWN:
                    v_axis_pos = 1
                elif event.key == K_SPACE:
                    Fire = 1
                elif event.key == ord('t'):
                    turbo = 1
        elif event.type == KEYUP:
            if not gameOver:
                if event.key == K_SPACE:
                    Fire = 0
                elif event.key == K_LEFT or event.key == K_RIGHT:
                    h_axis_pos = 0
                elif event.key == K_UP or event.key == K_DOWN:
                    v_axis_pos = 0
                elif event.key == ord('t'):
                    turbo = 0
                


                    
            
    if initialScreen:
        windowSurface.blit(initialSurface, initialRect)
        initialElapsed =  int(time.time() - initialTime)
        if initialElapsed > 3:
            initialScreen = False

    elif not gameOver:

        if joystick_count == 0:
            ## code for no joystick
            pass

        else:
            h_axis_pos = my_joystick.get_axis(0)
            v_axis_pos = my_joystick.get_axis(1)

            Fire = my_joystick.get_button(7)
            turbo = my_joystick.get_button(2)
        if Fire == 1:
            gunChannel = pygame.mixer.Channel(3)
            gunChannel2 = pygame.mixer.Channel(4)
            gunChannel3 = pygame.mixer.Channel(5)
            if not gunChannel.get_busy():
                gunChannel.play(pistol_snd)
            elif not gunChannel2.get_busy():
                gunChannel2.play(pistol_snd)
            else:
                gunChannel3.play(pistol_snd)

        if turbo == 0:
            playerGunSpeed = 7
        elif turbo == 1:
            playerGunSpeed = 14

        if x < 0:
            x = 1
        elif x > 700:
            x = 700
        else:
            if Fire == 0:
                x = int(x + h_axis_pos * playerGunSpeed)

        if y < 0:
            y = 0
        elif y > 500:
            y = 500
        else: 
            if Fire == 0:
                y = int(y + v_axis_pos * playerGunSpeed)


        crosshair_rect.left = x
        crosshair_rect.top = y

        ## move the small center rect of the crosshair with the center of the
        ## main crosshair image
        crosshairCenterRect.center = crosshair_rect.center


        windowSurface.blit(background, Back)

        for enemy in enemies:
            enemy.setPosition(targetStartSpeed)
            windowSurface.blit(enemy.img, enemy.rect)
            enemy.move()
            hit = crosshairCenterRect.colliderect(enemy.rect)
            if enemy.rect.top > 600:
                enemiesNumber = enemiesNumber + 1
                if enemy.enemyType == "plane_down_left":
                    enemy.plane(4)
                elif enemy.enemyType == "parachute":
                    enemy.parachute(random.randrange(0,5))
                elif enemy.enemyType == "bomb":
                    enemy.bomb(random.randrange(0,5))

            if Fire == 1 and hit:
                windowSurface.fill(RED)
                explodeChannel = pygame.mixer.Channel(0)
                if explodeChannel.get_busy():
                    channel2 = pygame.mixer.Channel(1)
                    channel2.play(explode_snd)
                else:
                    explodeChannel.play(explode_snd)
                killNumber = killNumber + 1
                if enemy.enemyType == "plane_down_left":
                    enemy.plane(4)
                elif enemy.enemyType == "bomb":
                    enemy.bomb(random.randrange(0,5))

        # crosshair should be blitted last to be on top of
        # enemy targets
        windowSurface.blit(crosshair_img, crosshair_rect)
        windowSurface.blit(gun_img, gun_rect)

        #### Timer Box
        elapsedTime = int(time.time() - startTime)
        gameTimeSurface = gameFont.render("Time: " + str(elapsedTime), True, (255, 0, 0))
        windowSurface.blit(gameTimeSurface, timerBox)

        ### Enemies
        enemiesSurface = gameFont.render("Enemies Landed: " + str(enemiesNumber), True, (255, 0, 0))
        windowSurface.blit(enemiesSurface, enemiesBox)

        # Kills
        killSurface = gameFont.render("Kills : " + str(killNumber), True, (255, 0, 0))
        windowSurface.blit(killSurface, killBox)

        ## limit framerate to 50
        clock.tick(50)
        if elapsedTime > 30:
            gameOver = True


        
    elif gameOver:
        gameOverRect = pygame.Rect(0, 0, WIDTH, HEIGHT)
        windowSurface.blit(gameOverImg, gameOverRect)
#        pygame.draw.rect(windowSurface, BLACK, gameOverRect)
        windowSurface.blit(gameOverSurface, gameOverBox)
        score = killNumber - enemiesNumber
        scoreSurface = gameFont.render("SCORE: " + str(score), True, 
                                       (255, 0, 0))
        scoreRect = scoreSurface.get_rect(centerx = WIDTH/2, top = HEIGHT/3 * 2)
        windowSurface.blit(scoreSurface, scoreRect)
        playAgainSurface = gameFont.render("Play Again (Y/N)?", True, (255, 0, 0))
        playAgainRect = playAgainSurface.get_rect(centerx = WIDTH/2, 
                                                  top = scoreRect.bottom + 20)
        windowSurface.blit(playAgainSurface, playAgainRect)


    pygame.display.update()
